macroScript QuickMirrorTransformXController category:"Controllers" tooltip:"Quick MirrorTransformX Controller"
(
	if selection.count > 0 then for obj in selection do
	(
		obj.parent = undefined
		
		-- find object closest to mirrored position
		
		local mirroredObject = objects[1]
		local minDistance = abs (mirroredObject.transform[4].x + obj.transform[4].x) 
		local normalSum = abs (mirroredObject.transform[3].x + obj.transform[3].x) 
		
		for o in objects where ( tempDistance = abs (o.transform[4].x + obj.transform[4].x) ) <= minDistance do
		(
			local tempSum = abs (o.transform[3].x + obj.transform[3].x)
			
			if tempDistance == minDistance then 
			(
				if tempSum < normalSum then 
				(
					mirroredObject = o
					normalSum = tempSum
				)
			)
			else 
			(
				mirroredObject = o
				normalSum = tempSum
			)
			minDistance = tempDistance
		)
		
		-- apply mirror transform controller
		
		local controllerString = obj.transform.controller as string
		
		if controllerString == "Controller:IKChainControl" then 
		(
			obj.transform.controller.IK_Goal.controller = MirrorTransformX ()
			obj.transform.controller.IK_Goal.controller.pick = mirroredObject
		)
		else if controllerString == "Controller:IKControl" then
		(
			obj.transform.controller.FK_Sub_Control.controller = MirrorTransformX ()
			obj.transform.controller.FK_Sub_Control.controller.pick = mirroredObject
		)
		else
		(
			obj.transform.controller = MirrorTransformX ()
			obj.transform.controller.pick = mirroredObject
		)
	)
)